---
title: InputEvent.data
slug: Web/API/InputEvent/data
tags:
  - API
  - DOM Events
  - Experimental
  - Input
  - InputEvent
  - Property
  - Reference
  - data
  - events
---
<p>{{APIRef("DOM Events")}}</p>

<p>The <strong><code>data</code></strong> read-only property of the {{domxref("InputEvent")}} interface returns a {{domxref("DOMString")}} with inserted characters. This may be an empty string if the change doesn't insert text, such as when characters are deleted.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>aString</em> = <em>inputEvent</em>.data;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h2 id="Examples">Examples</h2>

<p>In the following example, an event listener receives the <a href="/en-US/docs/Web/API/HTMLElement/input_event">input</a> event. Any textual change to the {{htmlelement("input")}} element is retrieved by <code>InputEvent.data</code> and inserted into a paragraph using the <code><a href="/en-US/docs/Web/API/Node/textContent">Node.textContent</a></code> property.</p>

<pre class="brush: html notranslate">&lt;p&gt;Some text to copy and paste.&lt;/p&gt;

&lt;input type="text"&gt;

&lt;p class="result"&gt;&lt;/p&gt;</pre>

<pre class="brush: js notranslate">var editable = document.querySelector('input');
var result = document.querySelector('.result');

editable.addEventListener('input', (e) =&gt; {
  result.textContent = "Inputted text: " + e.data;
});</pre>

<p>{{EmbedLiveSample('Examples')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('InputEvents2','#dfn-data','data')}}</td>
   <td>{{Spec2('InputEvents2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.InputEvent.data")}}</p>
</div>
